VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2220
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   2415
   LinkTopic       =   "Form1"
   ScaleHeight     =   2220
   ScaleWidth      =   2415
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   1920
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   615
   End
   Begin VB.PictureBox picLaser 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   1380
      Left            =   0
      ScaleHeight     =   88
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   157
      TabIndex        =   0
      Top             =   840
      Width           =   2415
   End
   Begin VB.Label lblY 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1200
      TabIndex        =   5
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label lblX 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1200
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Y"
      Height          =   255
      Index           =   1
      Left            =   960
      TabIndex        =   3
      Top             =   480
      Width           =   135
   End
   Begin VB.Label Label1 
      Caption         =   "X"
      Height          =   255
      Index           =   0
      Left            =   960
      TabIndex        =   2
      Top             =   120
      Width           =   135
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_NumIgnored As Integer
Private m_IgnoredR() As Byte
Private m_IgnoredG() As Byte
Private m_IgnoredB() As Byte
Private Sub cmdGo_Click()
Const MIN_BRIGHTNESS = 30

Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim bytes_per_scanLine As Integer
Dim pad_per_scanLine As Integer
Dim X As Integer
Dim Y As Integer
Dim i As Integer
Dim ignore_pixel As Boolean
Dim x_moment As Double
Dim y_moment As Double
Dim brightness As Double
Dim total_brightness As Double

    Screen.MousePointer = vbHourglass
    cmdGo.Enabled = False
    DoEvents

    ' Prepare the bitmap description.
    With bitmap_info.bmiHeader
        .biSize = 40
        .biWidth = picLaser.ScaleWidth
        ' Use negative height to scan top-down.
        .biHeight = -picLaser.ScaleHeight
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        bytes_per_scanLine = ((((.biWidth * .biBitCount) + 31) \ 32) * 4)
        pad_per_scanLine = bytes_per_scanLine - (((.biWidth * .biBitCount) + 7) \ 8)
        .biSizeImage = bytes_per_scanLine * Abs(.biHeight)
    End With

    ' Load the bitmap's data.
    ReDim pixels(1 To 4, 1 To picLaser.ScaleWidth, 1 To picLaser.ScaleHeight)
    GetDIBits picLaser.hdc, picLaser.Image, _
        0, picLaser.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS

    ' Modify the pixels.
    For Y = 1 To picLaser.ScaleHeight
        For X = 1 To picLaser.ScaleWidth
            ' See if we should ignore this pixel.
            ignore_pixel = False
            For i = 1 To m_NumIgnored
                If m_IgnoredR(i) = pixels(pixR, X, Y) And _
                   m_IgnoredG(i) = pixels(pixG, X, Y) And _
                   m_IgnoredB(i) = pixels(pixB, X, Y) _
                Then
                    ignore_pixel = True
                    Exit For
                End If
            Next i

            brightness = CDbl(pixels(pixR, X, Y)) + pixels(pixG, X, Y) + pixels(pixB, X, Y)
            If brightness < MIN_BRIGHTNESS Then ignore_pixel = True

            ' Process the pixel.
            If ignore_pixel Then
                pixels(pixR, X, Y) = 64
                pixels(pixG, X, Y) = 64
                pixels(pixB, X, Y) = 64
            Else
                total_brightness = total_brightness + brightness
                x_moment = x_moment + X * brightness
                y_moment = y_moment + Y * brightness
            End If
        
        
        Next X
    Next Y

    ' Display the result.
    SetDIBits picLaser.hdc, picLaser.Image, _
        0, picLaser.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS
    picLaser.Picture = picLaser.Image

    ' Display the results.
    x_moment = x_moment / total_brightness
    y_moment = y_moment / total_brightness
    lblX.Caption = Format$(x_moment, "0.00")
    lblY.Caption = Format$(y_moment, "0.00")
    picLaser.PSet (x_moment, y_moment), vbBlue
    picLaser.Circle (x_moment, y_moment), 5, vbBlue
    picLaser.Line (x_moment + 5, y_moment + 5)-Step(5, 5), vbBlue
    picLaser.Line (x_moment - 5, y_moment + 5)-Step(-5, 5), vbBlue
    picLaser.Line (x_moment - 5, y_moment - 5)-Step(-5, -5), vbBlue
    picLaser.Line (x_moment + 5, y_moment - 5)-Step(5, -5), vbBlue

    Screen.MousePointer = vbDefault
End Sub
Private Sub Form_Load()
Dim ignored_colors As Variant
Dim i As Integer
Dim j As Integer

    ignored_colors = Array(&H8080FF, &HC0, &HC0FFFF)
    m_NumIgnored = UBound(ignored_colors) - LBound(ignored_colors) + 1

    ReDim Preserve m_IgnoredR(1 To m_NumIgnored)
    ReDim Preserve m_IgnoredG(1 To m_NumIgnored)
    ReDim Preserve m_IgnoredB(1 To m_NumIgnored)

    j = 1
    For i = LBound(ignored_colors) To UBound(ignored_colors)
        m_IgnoredR(j) = ignored_colors(i) Mod 256
        m_IgnoredG(j) = (ignored_colors(i) \ 256) Mod 256
        m_IgnoredB(j) = ignored_colors(i) \ 256 \ 256
        j = j + 1
    Next i

    dlgFile.InitDir = App.Path
    dlgFile.Filter = "Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*"
    dlgFile.FilterIndex = 1
    dlgFile.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgFile.CancelError = True
End Sub

Private Sub mnuFileOpen_Click()
    On Error Resume Next
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox Err.Description
    Else
        picLaser.Picture = LoadPicture(dlgFile.FileName)
        Width = Width - ScaleWidth + _
            picLaser.Width
        Height = Height - ScaleHeight + _
            picLaser.Height + picLaser.Top
        cmdGo.Enabled = True
    End If
End Sub


Private Sub picLaser_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Debug.Print Hex$(picLaser.Point(X, Y))
End Sub


